
Requirements
============

 - PHP enabled web server (5.0 or higher required)
 - MySQL database (4.0 or higher required)
 - GnuChess and/or Phalanx (to enable robots)
 - Python (to enable robots)
 - NodeJS (to enable real time gaming)

Server Setup
============

Extract the files to a directory accessible by the web server. The files that
must be served are in the www directory.

Create an account and a database on the MySQL server
Run the create_database.sql script to create all the tables.
Run the insert_initial_data.sql script to populate the database.

If you are upgrading from a previous version, instead of running the
create_database/insert_initial_data scripts, run the migration scripts
provided for your version..

Copy local_settings.php_DIST to local_settings.php.
Open it and customise it to match your settings.

NodeJS
======

Install `npm` and `nodejs`. Under `www/js/realtime` directory install:

- [node-mysql](https://github.com/felixge/node-mysql)
- [underscore](http://underscorejs.org)
- [socket.io](https://github.com/LearnBoost/socket.io)
- [forever](https://github.com/nodejitsu/forever)

    cd .../www/js/realtime
    npm install mysql
    npm install underscore
    npm install socket.io
    npm install forever

If you are an ubuntu user you can create an startup script at: `/etc/init/node-mkgichess.conf` see
[kvz](http://kevin.vanzonneveld.net/techblog/article/run_nodejs_as_a_service_on_ubuntu_karmic/) and
[SO](http://stackoverflow.com/questions/11084279/node-js-setup-for-easy-deployment-and-updating/11157223)
in order to have the node aplication running as a deamon.

Create `pids` and `logs` directory under *$HOME* and make them writable. Create a
file `.foreverignore` on same directory and add:

    pids/**
    logs/**

After this, you can: `sudo initctl start node-mkgichess` to start the node server, forever module
should take care of application restarting on crash.

For debian users, the sample init script provided can be used, copy it to: `/etc/init.d` then:

    sudo update-rc.local node-mkgichess defaults

When using debian init script, `forever` must be installed globally or at least accessible to the path. On `initnode` folder two samples scripts can be found for this purpose.


Notification Setup
==================

To enable periodic notification and other regular tasks, add the
following lines to your crontab:

21    *       *       *       *       cd /PATH_TO_CHESSCLUB && /usr/bin/php5 admin_notification.php >/dev/null 2>&1
30    2       *       *       *       cd /PATH_TO_CHESSCLUB && /usr/bin/php5 admin_flag_active_players.php >/dev/null 2>&1
35    9       *       *       *       cd /PATH_TO_CHESSCLUB && /usr/bin/php5 admin_remind_subscription.php >/dev/null 2>&1

Alternatively, you can add these rules in a file in /etc/cron.d


Game Analysis Setup
===================

To enable full game analysis feature in history browser, you have to download
the analysis script from SVN at:
https://mkgichessclub.svn.sourceforge.net/svnroot/mkgichessclub/ChessTeacher/

Install the analysis.py file on your system. You can customize the first lines to
match with your system.

Then add a periodic crontab item like this:
31    *       *       *       *       python /usr/local/mkgichessclub/ChessTeacher/analyze.py <db_host> <db_user> <db_pwd> <db_base> >/dev/null 2>&1


Robots Setup
============

If you have admin rights on your web server, it should not be too complicated for you
to install gnuchess and/or phalanx chess engines. Once they are installed, update your
local_settings.php file to set the path to the executables. Once these paths are set,
the robots will play instantly.

Be careful though that robot identifiers should contain the name of the engine and end
with the desired thinking depth. If you used the insert_initial_data.sql script, you
shouldn't have any issue with this.


If you have any question, contact us at contact@chess.mkgi.net
