<?php

/*
 * This script will remove escaped html expressions in the database since
 * we no longer escape them during the input parameter parsing.
 *
 * It should be run AFTER the corresponding sql migration script.
 */

require("../www/mcc_common.php");

DecodeEntities($mysql_table_move, "mv_id", "mv_chat");
DecodeEntities($mysql_table_player, "pl_identifier", "pl_real_name");

function DecodeEntities ( $table, $field_id, $field_text ) {
	$q = sql_query("select $field_id, $field_text from $table where $field_text is not null");

	$updates = 0;

	foreach($q as $row) {
		$html = $row[$field_text];
		$text = html_entity_decode($html, ENT_QUOTES, "UTF-8");

		if ( $html != $text ) {
			// echo "Html: " . $html . "\n";
			// echo "Text: " . $text . "\n";
			sql_exec("update ? set ? = ? where ? = ?",
			     array($table, $field_text, $text, $field_id, $row[$field_id]));
			$updates++;
		}
	}

	echo "$updates updates for field $field_text in table $table\n";
}

?>
