-- The aim of this migration script is to convert all text-based fields to either
-- us-ascii or utf8 formats.

-- We have to disable foreign keys during the process.
set FOREIGN_KEY_CHECKS = 0;

alter table mcc_player
 modify column `pl_identifier` varchar(24) character set ascii collate ascii_general_ci not null,
 modify column `pl_password` varchar(16) character set utf8 collate utf8_general_ci not null,
 modify column `pl_real_name` varchar(32) character set utf8 collate utf8_general_ci default null,
 modify column `pl_gender` char(1) character set ascii collate ascii_bin default null,
 modify column `pl_email_address` varchar(64) character set ascii collate ascii_bin default null,
 modify column `pl_country` char(2) character set ascii collate ascii_bin default null,
 modify column `pl_notification_delay` char(2) character set ascii collate ascii_bin not null,
 default charset utf8;

alter table mcc_article
 modify column `art_lang` char(2) character set ascii collate ascii_general_ci not null,
 modify column `art_author` varchar(24) character set ascii collate ascii_general_ci not null,
 modify column `art_category` varchar(8) character set ascii collate ascii_general_ci not null,
 modify column `art_text` text character set utf8 collate utf8_general_ci not null,
 modify column `art_title` varchar(32) character set utf8 collate utf8_general_ci default null,
 default charset utf8;

alter table mcc_email_token
 modify column `et_player` varchar(24) character set ascii collate ascii_general_ci not null,
 modify column `et_token` varchar(8) character set ascii collate ascii_general_ci not null,
 modify column `et_email_address` varchar(64) character set ascii collate ascii_bin not null,
 default charset utf8;

alter table mcc_game
 modify column `gm_player_white` varchar(24) character set ascii collate ascii_general_ci not null,
 modify column `gm_player_black` varchar(24) character set ascii collate ascii_general_ci not null,
 modify column `gm_status` varchar(8) character set ascii collate ascii_general_ci not null,
 default charset utf8;

alter table mcc_history_connection
 modify column `hc_identifier` varchar(24) character set ascii collate ascii_general_ci not null,
 default charset utf8;

alter table mcc_history_score
 modify column `hs_identifier` varchar(24) character set ascii collate ascii_general_ci not null,
 default charset utf8;

alter table mcc_invitation
 modify column `iv_player` varchar(24) character set ascii collate ascii_general_ci not null,
 modify column `iv_invited_address` varchar(64) character set ascii collate ascii_bin not null,
 modify column `iv_invited_name` varchar(32) character set utf8 collate utf8_general_ci not null,
 modify column `iv_invited_player` varchar(24) character set ascii collate ascii_general_ci default null,
 default charset utf8;

alter table mcc_move
 modify column `mv_short` varchar(10) character set ascii collate ascii_general_ci not null,
 modify column `mv_long` varchar(64) character set utf8 collate utf8_general_ci not null,
 modify column `mv_chat` text character set utf8 collate utf8_general_ci default null,
 modify column `mv_teachermove` varchar(128) character set ascii collate ascii_general_ci default null,
 default charset utf8;

alter table mcc_note
 modify column `nt_owner` varchar(24) character set ascii collate ascii_general_ci not null,
 modify column `nt_text` text character set utf8 collate utf8_general_ci not null,
 default charset utf8;

alter table mcc_player_portrait
 modify column `pp_player` varchar(24) character set ascii collate ascii_general_ci not null,
 modify column `pp_type` varchar(16) character set utf8 collate utf8_general_ci not null,
 default charset utf8;
