<?php

class Tip {
	public $tip_text;

	function Tip ( $p_lang = "EN") {
		global $mysql_table_article;

		$q = sql_query("select art_text from $mysql_table_article"
				. " where art_category='tips' and art_lang='$p_lang'"
				. " order by rand() limit 1");
		$this->tip_text = NULL;

		if ( ! empty($q) ) {
			$r = array_shift($q);

			if ( $r ) {
				$this->tip_text = $r["art_text"];
			}
		}
	}

	function getText() {
		return $this->tip_text;
	}
};


class Article {
	public $art_author;
	public $art_title;
	public $art_date;
	public $art_text;

	/* An article can be constructed in 2 different ways:
	 *   - By giving its ID (not implemented yet)
	 *   - By giving all its components
	 */
	function Article ( $p_id, $p_author = NULL, $p_title = NULL,
				$p_date = NULL, $p_text = NULL ) {
		if ( $p_id ) {
			// TODO: Load details from database
		}
		else {
			$this->art_author = $p_author;
			$this->art_title  = $p_title;
			$this->art_date   = $p_date;
			$this->art_text   = $p_text;
		}
	}

	function getAuthor() {
		return ucfirst($this->art_author);
	}

	function getTitle() {
		return ucfirst($this->art_title);
	}

	function getDate() {
		return $this->art_date;
	}

	function getText() {
		return $this->art_text;
	}
};


class ArticleSet {
	public $aset_articles;

	function ArticleSet ( $p_count, $p_lang = "EN" ) {
		global $mysql_table_article;
		$this->aset_articles = array();

		$q = "select art_author, art_title, UNIX_TIMESTAMP(art_date), art_text"
			. " from $mysql_table_article"
			. " where art_category='news' and art_lang='$p_lang'"
			. "   and art_date > now() - interval '1' month"
			. " order by art_date desc limit $p_count";

		$r = sql_query($q);

		foreach($r as $row) {
			$art = new Article(
			     NULL, $row['art_author'], $row['art_title'],
			     $row['UNIX_TIMESTAMP(art_date)'], $row['art_text']);
			$this->aset_articles[] = $art;
		}
	}

	function size() {
		return count($this->aset_articles);
	}

	function getArticle ( $p_index ) {
		return $this->aset_articles[$p_index];
	}
};

?>
