<?php

function mcc_template_move_history ( $p_game, $p_insert_js = FALSE, $p_display_score = FALSE )
{
	$moves = $p_game->getMoves();

	$result  = "";
	$result .= "<table class='movehistory'>\n";

	$js_index = 0;
	$turn     = 1;

	if ( count($moves) == 0 ) {
		$result .= "<tr><td class='movehistory_move_odd'
					colspan='3'
					style='font-style: italic;'>&nbsp;No moves.</td></tr>\n";
	}

	// Beware the lame double i++ !!
	for ( $i = 0; $i < count($moves); ) {
		if ( $turn % 2 == 0 ) {
			$parity = 'even';
		}
		else {
			$parity = 'odd';
		}

		$move = $moves[$i++];

		$hidehints = $p_game->isOpen() && $i >= count($moves) - HINTS_HIDING;
		$quality = '';

		if ( $p_display_score && !$hidehints && $move->isAnalysisAvailable() ) {
			if ( $move->getTeacherRate() < -300 ) {
				$quality = 'bad';
			}
		}

		$result .= "<tr>\n";

		if ( $p_insert_js ) {
			$result .= "<td class='movehistory_mark_$parity'>"
				.  "<img name='histmark{$js_index}' src='images/spacer.png' alt='' /></td>\n";
		}

		$result .= "<td class='movehistory_count_$parity'>$turn.</td>\n";

		if ( $p_insert_js ) {
			$result .= "<td class='movehistory_{$quality}move_$parity'>&nbsp;"
						. "<a href='$js_index' onclick='return gotoMove($js_index);'>"
						. $move->getShort() . "</a></td>\n";
		}
		else {
			$result .= "<td class='movehistory_{$quality}move_$parity'>&nbsp;"
						. $move->getShort() . "</td>\n";
		}

		$js_index++;

		if ( $i < count($moves) ) {
			$move = $moves[$i++];

			$hidehints = $p_game->isOpen() && $i >= count($moves) - HINTS_HIDING;
			$quality = '';

			if ( $p_display_score && !$hidehints && $move->isAnalysisAvailable() ) {
				if ( $move->getTeacherRate() < -300 ) {
					$quality = 'bad';
				}
			}

			if ( $p_insert_js ) {
				$result .= "<td class='movehistory_{$quality}move_$parity'>&nbsp;"
						. "<a href='$js_index' onclick='return gotoMove($js_index);'>"
						. $move->getShort() . "</a></td>\n";
			}
			else {
				$result .= "<td class='movehistory_{$quality}move_$parity'>&nbsp;"
						. $move->getShort() . "</td>\n";
			}
			$js_index++;

			if ( $p_display_score ) {
				if ( !$hidehints && $move->isAnalysisAvailable() ) {
					$result .= "<td class='movehistory_move_$parity'>"
						. mcc_template_scorebar($move->getScore()) . "</td>\n";
				}
				else {
					$result .= "<td class='movehistory_move_$parity'></td>\n";
				}
			}
		}
		else {
			$result .= "<td class='movehistory_move_$parity'></td>\n";
			if ( $p_display_score ) {
				$result .= "<td class='movehistory_move_$parity'></td>\n";
			}
		}


		$result .= "</tr>\n";
		$turn++;
	}

	$result .= "</table>\n";

	if ( $p_insert_js ) {
		$result .= <<<EOT
<script language="Javascript" type="text/javascript">
<!--
	move_count=$js_index;
	orig_move_count = move_count;
// -->
</script>
EOT;
	}

	return mcc_template_box("Move History", $result, FALSE);
}

define("MAX_SCORE", 1000);

function mcc_template_scorebar ( $p_score, $p_width = 30 ) {
	if ( $p_score < 0 ) {
		$score_white = min(-$p_score, MAX_SCORE);
		$score_black = 0;
	}
	else {
		$score_white = 0;
		$score_black = min($p_score, MAX_SCORE);
	}

	$width_white = $p_width * $score_white / MAX_SCORE;
	$width_black = $p_width * $score_black / MAX_SCORE;
	$width_whole = 2 * $p_width + 2 * 8 + 5;

	$result = "";
	$result .= "<div style='width: {$width_whole}px;'>";
	$result .= "<img src='images/scorebar_0.png' style='height: 14px; width: " . ($p_width - $width_white) . "px;' />";
	$result .= "<img src='images/scorebar_a.png' />";
	$result .= "<img src='images/scorebar_b.png' style='height: 14px; width: " . ($width_white) . "px;' />";
	$result .= "<img src='images/scorebar_c.png' style='height: 14px; width: 3px;' />";
	$result .= "<img src='images/scorebar_d.png' style='height: 14px; width: " . ($width_black) . "px;' />";
	$result .= "<img src='images/scorebar_e.png' />";
	$result .= "<img src='images/scorebar_0.png' style='height: 14px; width: " . ($p_width - $width_black) . "px;' />";
	$result .= "</div>";

	return $result;
}

define("BOARDVIEW_STANDARD", 0);
define("BOARDVIEW_STRATEGIC", 1);

function mcc_template_board ( $p_game, $p_black = FALSE, $p_viewmode = BOARDVIEW_STANDARD,
				$p_insert_js = FALSE, &$p_board, &$p_diff, $p_absolute = TRUE )
{
	global $t_frame_color;
	global $mcc_server_root;

	if ( $p_absolute ) {
		$imgroot = $mcc_server_root . "images";
	}
	else {
		$imgroot = "images";
	}

	$result = "";

	$boardview_mode = $p_viewmode;

	if ( $p_black ) {
		$index       =  7;
		$pos_change  = -1;
		$line_change = 16;
	}
	else {
		$index       =  56;
		$pos_change  =   1;
		$line_change = -16;
	}

	$result .= "<table cellpadding=\"4\"><tr>\n";
	$result .= "<td bgcolor=\"$t_frame_color\">\n";
	$result .= "<table class='chessboard' cellspacing=\"0\">\n";

	if ( $boardview_mode == BOARDVIEW_STRATEGIC ) {
		$total_menace_black = 0;
		$total_menace_white = 0;
	}

	for ( $y = 0; $y < 9; $y++ ) {
		$result .= "<tr>\n";
		for ( $x = 0; $x < 9; $x++ ) {
			if ( $y == 8 ) {
				if ( $x > 0 ) {
					if ( ! $p_black )	$c = chr(96+$x);
					else			$c = chr(96+9-$x);

					$result .= "<td class=\"board_cell_coordinate\">$c</td>\n";
				}
				else {
					$result .= "<td></td><td></td>\n";
				}
			}
			else if ( $x == 0 ) {
				if ( ! $p_black ) {
					$i = 8 - $y;
				}
				else {
					$i = $y + 1;
				}

				// The useless spacer column should be removed...
				$result .= "<td class=\"board_cell_coordinate\">$i</td><td>&nbsp;</td>\n";
			}
			else {
				$entry = $p_board[$index];
				$color = substr( $entry, 0, 1);
				$name  = getFullFigureName((strlen($entry)>1)?$entry[1]:NULL);
				$tilestyle = '';
				$tileclass = '';

				if ( $boardview_mode == BOARDVIEW_STRATEGIC ) {
					$att_b = countTileAttacks($p_board, "b", $index);
					$att_w = countTileAttacks($p_board, "w", $index);

					$total_menace_black += $att_b;
					$total_menace_white += $att_w;

					$coef = $att_b - $att_w;
					$tile_r = 255;
					$tile_g = 255;
					$tile_b = 255;

					if ( $coef > 0 ) {
						$tile_g -= $coef * 20 + 40;
						$tile_b -= $coef * 20 + 40;
					}
					if ( $coef < 0 ) {
						$tile_r -= -$coef * 20 + 40;
						$tile_g -= -$coef * 20 + 40;
					}

					if ( $tile_r < 0 )      $tile_r = 0;
					if ( $tile_g < 0 )      $tile_g = 0;
					if ( $tile_b < 0 )      $tile_b = 0;

					$tilecol   = sprintf("#%02X%02X%02X", $tile_r, $tile_g, $tile_b);
					$tilestyle = "background: $tilecol;";
				}
				else {
					if ( (($y+1)+($x)) % 2 == 0 ) {
						$tileclass = 'b_std_white';
					}
					else {
						$tileclass = 'b_std_black';
					}
				}

				$cursor  = 'default';
				$imagescript = '';

				if ( $name != "empty" ) {
					$imagesrc    = "$imgroot/wcg/$color$name.png";

					if ( $color == "w" ) {
						$imagealt = "White $name";
					}
					else {
						$imagealt = "Black $name";
					}

					if ( $p_black )		$player_col = "b";
					else			$player_col = "w";

					if ( $player_col != $p_board[$index][0] ) {
						$cmdpart = sprintf( "x%s", boardIndexToCoord($index) );
					}
					else {
						$cmdpart = sprintf( "%s%s", $p_board[$index][1], boardIndexToCoord($index) );
						$cursor = 'pointer';
						$imagescript  = " onload=\"dnd_registerSource(this, '$cmdpart');\"";
					}
				}
				else {
					$imagesrc    = "$imgroot/wcg/empty.png";
					$imagealt    = "Empty";
					$cmdpart     = sprintf( "-%s", boardIndexToCoord($index) );
				}

				$result .= "<td id='xb$index' class='$tileclass' style='$tilestyle'>";
				if ( $p_insert_js ) {
					$result .= "<div id='$cmdpart' style='margin: 0px; padding: 0px; "
							. "width: 36px; height: 36px; cursor: $cursor;' "
							. "onclick='clickHandler(\"$cmdpart\");' >";
					$result .= "<img id='img-$cmdpart' src='$imagesrc' alt='$imagealt' $imagescript />";
					$result .= "</div>";
					$result .= "</td>\n";
					$result .= "<script language='JavaScript'>";
					$result .= "dnd_registerTarget(document.getElementById('xb$index'), '$cmdpart');";
					$result .= "</script>";
				}
				else {
					$result .= "<img src='$imagesrc' alt='$imagealt' />";
					$result .= "</td>\n";
				}

				$index += $pos_change;
			}
		}
		$index += $line_change;
		$result .= "</tr>\n";
	}

	$result .= "</table></td>\n";

	if ( !empty($p_diff) ) {
		$diff_names = array( "pawn", "knight", "bishop", "rook", "queen" );

		$result .= '<td style="background: #ffffff;"><img width="10" alt="" src="' . $imgroot . '/spacer.png" /></td>';
		$result .= '<td style="background: #ffffff;">';
		$result .= '<table cellpadding="2" bgcolor="' . $t_frame_color . '">';
		$result .= '<tr><td valign="top">';

		// show superiority at top
		$draw_gap = 0;
		for( $i = 0; $i < 5; $i++ ) {
			$name = $diff_names[4-$i];

			if ( ! $p_black && $p_diff[4-$i]<0 ) {
				$draw_gap = 1;
				for ( $j = 0; $j < -$p_diff[4-$i]; $j++ )
					$result .= "<img alt=\"$name\" src=\"$imgroot/wcg/sb$name.png\" /><br />";
			}
			else if ( $p_black && $p_diff[4-$i]>0) {
				$draw_gap = 1;
				for ( $j = 0; $j < $p_diff[4-$i]; $j++ )
					$result .= "<img alt=\"$name\" src=\"$imgroot/wcg/sw$name.png\" /><br />";
			}
		}
		$result .= "</td></tr><tr><td><img width=\"2\" height=\"40\" src=\"$imgroot/spacer.png\" alt=\"\" /></td></tr><tr><td>";
		/* show superiority at bottom */
		for( $i = 0; $i < 5; $i++ ) {
			$name = $diff_names[$i];

			if ( ! $p_black && $p_diff[$i]>0 ) {
				for ( $j = 0; $j < $p_diff[$i]; $j++ )
					$result .= "<img alt=\"$name\" src=\"$imgroot/wcg/sw$name.png\" /><br />";
			}
			else if ( $p_black && $p_diff[$i]<0) {
				for ( $j = 0; $j < -$p_diff[$i]; $j++ )
					$result .= "<img alt=\"$name\" src=\"$imgroot/wcg/sb$name.png\" /><br />";
			}
		}
		$result .= "</td></tr></table></td>";
	}
	$result .= "</tr></table>";

	/* Build menace Bars... */

	if ( $boardview_mode == BOARDVIEW_STRATEGIC ) {
		$width_menace_white = 4 * $total_menace_white;
		$width_menace_black = 4 * $total_menace_black;

		if ( $width_menace_white > 300 || $width_menace_black > 300 ) {
			$coef = 300 / max($width_menace_white, $width_menace_black);
			$width_menace_white *= $coef;
			$width_menace_black *= $coef;
		}

		$result .= '<div class="menace_bars">';
		$result .= '<div class="menace_barw" style="width: ' . $width_menace_white . 'px;">' . $total_menace_white . '</div>';
		$result .= '<div class="menace_barb" style="width: ' . $width_menace_black . 'px;">' . $total_menace_black . '</div>';
		$result .= '</div>';
	}

	return $result;
}

?>