<?php

function mcc_template_form ( $p_action, $p_method, $p_message,
				$p_fields, $p_class = FALSE )
{
	if ( $p_class ) {
		$class = "class=\"$p_class\"";
	}
	else {
		$class = "";
	}

	$enctype = '';

	foreach ( $p_fields as $field ) {
		if ( $field[3] == 'file' ) {
			$enctype = 'enctype="multipart/form-data"';
		}
	}

	$result  = "";
	$result .= <<<EOT
<form action="$p_action" method="$p_method" $enctype>
<table $class>
EOT;

	if ( $p_message ) {
		$result .= <<<EOT
<tr>
	<td colspan="3" $class style="text-align: center;">
		$p_message
	</td>
</tr>
EOT;
	}

	foreach ( $p_fields as $field ) {
		$label  = $field[0];
		$name   = $field[1];
		$value  = mcc_htmlencode($field[2]);
		$type   = $field[3];
		$attrs  = $field[4];
		$help   = $field[5];

		if ( count($field) > 6 ) {
			$values = $field[6];
		}

		if ( $type == "label" ) {
			$result .= <<<EOT
	<td $class style="text-align: right;">
		$label
	</td>
	<td $class style="text-align: left;">
		$value
	</td>
	<td $class style="text-align: justify; font-size: smaller; width: 200px;">
		$help
	</td>
EOT;
		}
		else if ( $type == "submit" ) {
			$result .= <<<EOT
<tr>
	<td colspan="3" $class style="text-align: center;">
		<input type="submit" name="$name" value="$value" />
	</td>
</tr>
EOT;
		}
		else if ( $type == "hidden" ) {
			$result .= <<<EOT
	<input type="hidden" name="$name" value="$value" />
EOT;
		}
		else if ( $type == "file" ) {
			$result .= <<<EOT
<tr>
	<td colspan="3" $class style="text-align: center;">
		<input type="file" name="$name" />
	</td>
</tr>
EOT;
		}
		else if ( $type == "select" ) {
$result .= <<<EOT
<tr>
	<td $class style="text-align: right;">
		$label
	</td>
	<td $class style="text-align: left;">
EOT;

			$result .= "<select name=\"$name\" $attrs>";
				
			foreach( $values as $v_key => $v_val ) {
				if ( $v_key == $value ) {
					$sel = "SELECTED";
				}
				else {
					$sel = "";
				}

				$result .= "<option value=\"$v_key\" $sel>$v_val</option>";
			}
			  
			$result .= "</select>\n";
		
$result .= <<<EOT
	</td>
	<td $class style="text-align: justify; font-size: smaller; width: 200px;">
		$help
	</td>
</tr>
EOT;
		}
		else {
			$result .= <<<EOT
<tr>
	<td $class style="text-align: right;">
		$label
	</td>
	<td $class style="text-align: left;">
		<input type="$type" $attrs name="$name" value="$value" />
	</td>
	<td $class style="text-align: justify; font-size: smaller; width: 200px;">
		$help
	</td>
</tr>
EOT;
		}
	}

	$result .= <<<EOT
</table>
</form>
EOT;

	return $result;
}

?>