<?php

function mcc_template_menubar ( $p_context )
{
	$baritems = array();

	if ( is_array($p_context) ) {
		$context = $p_context[0];
		$gameid  = $p_context[1];
		$param   = $p_context[2];
	}
	else {
		$context = $p_context;
	}

	if ( $context == "index" || $context == "newgame" ) {
		$baritems['Home'] = 'club.php?glistsort='.GAMES_DEFAULT_SORT;
		$baritems['My Profile'] = 'player_profile_view.php';
		$baritems['Search'] = 'search.php';
		$baritems['Rankings'] = 'rankings.php';
        $baritems['All Players'] = 'players.php';
		$baritems['Invite a friend'] = 'invitation.php';
		$baritems['Help'] = 'help.php';
		$baritems['Logout'] = 'logout.php';
	}
	else if ( $context == "chess" ) {
        $baritems['Home'] = 'club.php?glistsort='.GAMES_DEFAULT_SORT;
		$baritems['History Browser'] = "browser.php?gameid=$gameid";

		if ( $param == 0 ) {
			$baritems['Strategic View'] = "chess.php?gameid=$gameid&amp;boardview=1";
		}
		else {
			$baritems['Normal View'] = "chess.php?gameid=$gameid&amp;boardview=0";
		}

		$baritems['PGN Format'] = "pgnformat.php?gameid=$gameid";
		$baritems['Invite a friend'] = 'invitation.php';
		$baritems['Help'] = 'help.php';
		$baritems['Logout'] = 'logout.php';
	}
	else if ( $context == "browser" ) {
		$baritems['Home'] = 'club.php?glistsort='.GAMES_DEFAULT_SORT;
		$baritems['Input Mode'] = "chess.php?gameid=$gameid";
		$baritems['Rotate Board'] = "browser.php?gameid=$gameid&amp;rotate=$param";
		$baritems['PGN Format'] = "pgnformat.php?gameid=$gameid";
		$baritems['Invite a friend'] = 'invitation.php';
		$baritems['Help'] = 'help.php';
		$baritems['Logout'] = 'logout.php';
	}
	else if ( $context == "help" ) {
		$baritems['Home'] = 'club.php?glistsort='.GAMES_DEFAULT_SORT;
		$baritems['Invite a friend'] = 'invitation.php';
		$baritems['Logout'] = 'logout.php';
	}
	else if ( $context == "search" || $context == "rankings" ) {
		$baritems['Home'] = 'club.php?glistsort='.GAMES_DEFAULT_SORT;
		$baritems['Help'] = 'help.php';
		$baritems['Logout'] = 'logout.php';
	}
	else if ( $context == "profile_edit" ) {
		$baritems['My Profile'] = 'player_profile_view.php';
		$baritems['Home'] = 'club.php?glistsort='.GAMES_DEFAULT_SORT;
		$baritems['Rankings'] = 'rankings.php';
        $baritems['All Players'] = 'players.php';
		$baritems['Invite a friend'] = 'invitation.php';
		$baritems['Help'] = 'help.php';
		$baritems['Logout'] = 'logout.php';
	}
	else if ( $context == "profile_view" ) {
		$baritems['Home'] = 'club.php?glistsort='.GAMES_DEFAULT_SORT;
		$baritems['Rankings'] = 'rankings.php';
		$baritems['Invite a friend'] = 'invitation.php';
		$baritems['Help'] = 'help.php';
		$baritems['Logout'] = 'logout.php';
	}
	else if ( $context == "invitation" ) {
		$baritems['Home'] = 'club.php?glistsort='.GAMES_DEFAULT_SORT;
		$baritems['My Profile'] = 'player_profile_view.php';
		$baritems['Search'] = 'search.php';
		$baritems['Rankings'] = 'rankings.php';
        $baritems['All Players'] = 'players.php';
		$baritems['Help'] = 'help.php';
		$baritems['Logout'] = 'logout.php';
	}


	$result  = "<div class='menubar'>";
	$result .= "[ ";
	$firstitem = TRUE;

	foreach ( $baritems as $label => $href ) {
		if ( $firstitem ) {
			$firstitem = FALSE;
		}
		else {
			$result .= " | ";
		}

		$result .= "<a href='{$href}'>{$label}</a>";
	}

	$result .= " ]";
	$result .= "</div>\n";

	return $result;
}


function mcc_template_userbar ( $p_user, $p_message = "Logged in as: " )
{
	if ( $p_user ) {
	$id     = $p_user->getIdentifier();
	$gamest = $p_user->getScoreGames();
	$wins   = $p_user->getScoreWins();
	$draws  = $p_user->getScoreDraws();
	$losses = $p_user->getScoreLosses();
	$points = $p_user->getScorePoints();

	$result = <<<EOT
<table class="userbar" style="width: 100%;">
<tr>
<td class="userbar_left">$p_message<strong>$id</strong></td>
<td class="userbar_right">
	$wins wins,
	$draws draws,
	$losses losses,
	$points Elo
</td>
</tr></table>
EOT;
	}

	return $result;
}

function mcc_template_footer()
{
	global $mcc_version;
	$version = "v" . implode(".", $mcc_version);
	$gentime = mcc_elapsed_time();
	$year = date('Y');

	try {
		$player = new Player();
	} catch ( Exception $e ) {
		$player = NULL;
	}

	if ( $player && $player->isAdmin() ) {
		$gentime_string = "Page built in $gentime ms<br />";
	}
	else {
		$gentime_string = "";
	}

	return <<<EOFOOT
<table style="width: 100%;">
<tr>
	<td class="tiny" style="vertical-align: top; text-align: left;">
	  MKGI Chess Club $version <br />
	  &copy; $year
	  <a href="http://www.alcibiade.org/">Alcibiade.org</a>
	</td>
	<td class="tiny" style="vertical-align: top; text-align: right;">
		$gentime_string
		<a href="mailto:contact@chess.mkgi.net">Contact Us</a>
	</td>
</tr>
</table>
EOFOOT;
}


//--- Main page layout ------------------------------------------------------

function mcc_template_page ($p_body, $p_menu_context = NULL, $p_title = NULL, $p_head = NULL )
{
	global $mcc_server_name;
	global $mcc_stylesheet_web;
	global $mcc_stylesheet_common;
	global $mcc_stylesheet_print;
	global $common_scripts;
    global $mcc_stylesheet_jqui;

	$result  = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
	$result .= "<html>\n";
	$result .= "<head>\n";
	$result .= "<link rel=\"stylesheet\" type=\"text/css\" href=\"$mcc_stylesheet_common\" />\n";
	$result .= "<link rel=\"stylesheet\" type=\"text/css\" href=\"$mcc_stylesheet_web\" />\n";
	$result .= "<link rel=\"stylesheet\" type=\"text/css\" media=\"print\" href=\"$mcc_stylesheet_print\" />\n";
    $result .= "<link rel=\"stylesheet\" type=\"text/css\" href=\"$mcc_stylesheet_jqui\" />\n";
	$result .= "<meta http-equiv='content-type' content='text/html; charset=utf-8' />\n";
	$result .= "<meta name=\"description\" content=\"MKGI Chess Club is an online chess-playing community. When you log in, you can play with other players and also compete against different chess software. Your profile and your ELO rating will be updated with every game you play and you will even be able to display game analysis made by a strong chess engine.\" />\n";

	if ( $p_title ) {
		$result .= "<title>$mcc_server_name : $p_title</title>\n";
	}
	else {
		$result .= "<title>$mcc_server_name</title>\n";
	}

	if ( $p_head ) {
		$result .= $p_head . "\n";
	}

	$result .= $common_scripts;

	$result .= "</head>\n";

	$result .= "<body>\n";
	$result .= "<div id='pageframe'>\n";
	$result .= "<div id='pagetopA'></div>\n";
	$result .= "<div id='pagetopB'></div>\n";

	$result .= "<div id='pagetopC'>";

	try {
		$result .= mcc_template_userbar(new Player());
	} catch ( Exception $e ) { }

	$result .= "</div>\n";

	if ( $p_menu_context ) {
		$result .= "<div id='pagetopD'>" . mcc_template_menubar($p_menu_context) . "</div>\n";
	}

	$result .= "<div id='pagebody_'>\n";
	$result .= "<div id='pagebody' align='center'>$p_body</div>\n";
	$result .= "</div>\n";
	$result .= "<div id='pagefooter'>" . mcc_template_footer() . "</div>\n";
	$result .= "</div>\n";
	$result .= "</body>\n";
	$result .= "</html>\n";

	return $result;
}

//--- Page Layouts ----------------------------------------------------------

function mcc_template_columns ( $p_columns_array )
{
	$result  = "";

	$result .= "<table><tr> <!-- COLS -->\n";

	for ( $cidx = 0; $cidx < count($p_columns_array); $cidx++ ) {
		$colhtml = $p_columns_array[$cidx];
		if ( $cidx == 0 ) {
			$colstyle = "vertical-align: top; width: 200px;";
		}
		else if ( $cidx == 1 ) {
			$colstyle = "vertical-align: top; width: 300px;";
		}
		else {
			$colstyle = "vertical-align: top;";
		}

		if ( $cidx == 0 ) {
			$result .= "<td style=\"$colstyle\"> <!-- COLS -->\n";
			$result .= $colhtml;
			$result .= "</td> <!-- COLS -->\n";
		}
		else {
			$result .= "<td style=\"$colstyle padding-left: 20px;\"> <!-- COLS -->\n";
			$result .= $colhtml;
			$result .= "</td> <!-- COLS -->\n";
		}
	}

	$result .= "</tr></table> <!-- COLS -->\n";

	return $result;
}

?>