<?php

function mcc_template_notebox ( $p_note )
{
	global $mcc_ajax_interval_fast, $mcc_ajax_interval_slow;
	
	$id = "note1";
	$text = mcc_htmlencode($p_note->getText());

	$url = AjaxNotesUrl($p_note->getGame());

	return <<<EOT
<div class="notewidget" id="$id">
<table class="mccbox" style="width: 100%;">
<tr><td class="mccbox_title">Your personal notes:</td></tr>
<tr><td class="mccbox_body">
	<textarea id="text$id"
		onchange="javascript: NoteUpdated();"
		 onkeyup="javascript: NoteUpdated();"
		>$text</textarea>
	<div class="status">
		<span id="status$id"></span>&nbsp;
		<a href="#"
			onClick="javascript: NoteSave(true); return false;"
		><img src="images/tango/16x16/actions/document-save.png" alt="Save this note" /></a>
	</div>
</td></tr>
</table>
</div>

<script language="javascript" type="text/javascript">

var noteLastUpdate = null;

setTimeout("CheckNoteUpdates()", $mcc_ajax_interval_fast / 2);

function NoteUpdated() {
	var statusElement = document.getElementById("status$id");
	noteLastUpdate = new Date();
	statusElement.innerHTML = "";
}

function CheckNoteUpdates() {
	var now = new Date();

	// console.log("Check for note update, noteLastUpdate=" + noteLastUpdate);
	
	if ( noteLastUpdate != null
		&& noteLastUpdate.getTime() + $mcc_ajax_interval_fast < now.getTime() ) {
		NoteSave(false);
	}
	
	setTimeout("CheckNoteUpdates()", $mcc_ajax_interval_fast / 2);
}

function NoteSave(explicit) {
	// console.log("Save");
	var textElement = document.getElementById("text$id");
	var statusElement = document.getElementById("status$id");
	var request = new XMLHttpRequest();

	request.open("GET", "$url&text=" + encodeURI(textElement.value), false);
	request.send(null);

	statusElement.innerHTML = "";

	if ( request.readyState == 4 ) {
		if ( explicit ) {
			statusElement.innerHTML = "Note saved.";
		} else {
			statusElement.innerHTML = "Note autosaved.";
		}
		
		noteLastUpdate = null;
	}
}

</script>

EOT;
}

?>
