<?php

function mcc_template_rankings ( $p_player = NULL, $p_linkprofiles = FALSE ) {
	$filter = mcc_get_page_parameter(RANKING_FILTER_VARNAME);

	if (       $filter != RANKING_FILTER_HUMANS
		&& $filter != RANKING_FILTER_ROBOTS
		&& $filter != RANKING_FILTER_ALL ) {

		$filter = RANKING_FILTER_HUMANS;
	}

	$pset = new PlayerSet();

	$result  = "";

	$result .= <<<EOT
<p style="text-align: center;"> <strong>User Rankings</strong> </p>


<table class="rankings" align="center">
<tr>
	<td class="rankings_title">Rank</td>
	<td class="rankings_title">Name</td>
	<td class="rankings_title" style="text-align: right;">Games</td>
	<td class="rankings_title" style="text-align: right;">Wins</td>
	<td class="rankings_title" style="text-align: right;">Draws</td>
	<td class="rankings_title" style="text-align: right;">Losses</td>
	<td class="rankings_title" style="text-align: right;">Rating</td>
</tr>
EOT;

	$players = $pset->getPlayersByRankDesc(RANKING_GAMES_MINI, $filter);

	$total_pages = ceil(count($players) / RANKING_PAGE);
	LogDebug("rp: " . RANKING_PAGE);
	LogDebug("players: " . count($players));
	LogDebug("Total Pages: " . $total_pages);

	$rpage = mcc_get_page_parameter(RANKING_PAGE_VARNAME);

	if ( $rpage ) {
		if ( $rpage < 1 ) {
			$rpage = 1;
		}

		if ( $rpage > $total_pages ) {
			$rpage = $total_pages;
		}
	}
	else {
		// This is False or in [0:count($players)-1]
		$player_rank = FALSE;

		for ( $r = 0; $r < count($players); $r++ ) {
			if ( $p_player == $players[$r] ) {
				$player_rank = $r;
				break;
			}
		}

		if ( $player_rank ) {
			$rpage = ceil(($player_rank + 1) / RANKING_PAGE);
		}
		else {
			$rpage = 1;
		}
	}

	$rank = 1 + ($rpage - 1) * RANKING_PAGE;

	foreach ( array_slice($players, ($rpage - 1) * RANKING_PAGE, RANKING_PAGE) as $player ) {
		if ( $player == $p_player ) {
			$class = "rankings_selected";
		}
		else {
			$class = "rankings";
		}

		if ( $p_linkprofiles ) {
			$link    = "<a href=\"player_profile_view.php?player="
				. $player->getIdentifier() . "\">";
			$linkend = "</a>";
		}
		else {
			$link    = "";
			$linkend = "";
		}

		$result .= "<tr>";
		$result .= "<td class=\"$class\" style=\"text-align: right;\">$rank.</td>";
		$result .= "<td class=\"$class\">$link" . $player->getIdentifier() . "$linkend</td>";
		$result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScoreGames() . "</td>";
		$result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScoreWins() . "</td>";
		$result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScoreDraws() . "</td>";
		$result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScoreLosses() . "</td>";
		$result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScorePoints() . "</td>";
		$result .= "</tr>\n";
		$rank++;
	}

	if ( $total_pages > 1 ) {
		$result .= "<tr><td class=\"rankings_pager\" colspan=\"7\">";

		if ( $rpage > 1 ) {
			$url = mcc_build_url(NULL, RANKING_PAGE_VARNAME, $rpage - 1);
			$result .= "<a href=\"$url\">&lt;</a> &nbsp;";
		}

		$page_first = max(1, $rpage - floor(SHOW_PAGES / 2));
		$page_last  = min($total_pages, $page_first + SHOW_PAGES);

		$result .= "Page &nbsp;";

		for ( $p = $page_first; $p <= $page_last; $p++ ) {
			if ( $rpage == $p ) {
				$result .= "<strong>$p</strong> &nbsp;";
			}
			else {
				$url = mcc_build_url(NULL, RANKING_PAGE_VARNAME, $p);
				$result .= "<a href=\"$url\">$p</a> &nbsp;";
			}
		}

		if ( $rpage < $total_pages ) {
			$url = mcc_build_url(NULL, RANKING_PAGE_VARNAME, $rpage + 1);
			$result .= "<a href=\"$url\">&gt;</a> ";
		}

		$result .= "</td></tr>";
	}

	$rankmin = RANKING_GAMES_MINI;

	$result .= "</table>";

	#--- Build the filter bar

	$filterbar = "<p style=\"text-align: center;\">[ ";

	if ( $filter == RANKING_FILTER_HUMANS ) {
		$filterbar .= "<strong>Show Only Humans</strong>";
	}
	else {
		$url = mcc_build_url(NULL, RANKING_FILTER_VARNAME, RANKING_FILTER_HUMANS);
		$filterbar .= "<a href=\"$url\">Show Only Humans</a>";
	}

	$filterbar .= " | ";

	if ( $filter == RANKING_FILTER_ROBOTS ) {
		$filterbar .= "<strong>Show Only Robots</strong>";
	}
	else {
		$url = mcc_build_url(NULL, RANKING_FILTER_VARNAME, RANKING_FILTER_ROBOTS);
		$filterbar .= "<a href=\"$url\">Show Only  Robots</a>";
	}

	$filterbar .= " | ";

	if ( $filter == RANKING_FILTER_ALL ) {
		$filterbar .= "<strong>Show Both</strong>";
	}
	else {
		$url = mcc_build_url(NULL, RANKING_FILTER_VARNAME, RANKING_FILTER_ALL);
		$filterbar .= "<a href=\"$url\">Show Both</a>";
	}

	$filterbar .= " ]</p>\n";

	$result .= $filterbar;
	#---

	$result .= <<<EOT
<p class="warning" style="text-align: center;">(You must have finished at least $rankmin games to show up.)</p>
EOT;

	return $result;
}

function mcc_template_allusers ( $p_player = NULL, $p_linkprofiles = FALSE ) {
    $filter = mcc_get_page_parameter(RANKING_FILTER_VARNAME);

    if ( $filter != RANKING_FILTER_HUMANS
        && $filter != RANKING_FILTER_ROBOTS
        && $filter != RANKING_FILTER_ALL ) {

        $filter = RANKING_FILTER_HUMANS;
    }

    $pset = new PlayerSet();

    $result  = "";

    $result .= <<<EOT
<p style="text-align: center;"> <strong>Players Currently Registered</strong> </p>


<table class="rankings" align="center">
<tr>
   <td class="rankings_title">Rank</td>
   <td class="rankings_title">Name</td>
   <td class="rankings_title" style="text-align: right;">Games</td>
   <td class="rankings_title" style="text-align: right;">Wins</td>
   <td class="rankings_title" style="text-align: right;">Draws</td>
   <td class="rankings_title" style="text-align: right;">Losses</td>
   <td class="rankings_title" style="text-align: right;">Rating</td>
</tr>
EOT;

    // call it with rank minimun on 0
    $players = $pset->getAllPlayersByRankDesc(0, $filter);

    $total_pages = ceil(count($players) / RANKING_PAGE);
    LogDebug("rp: " . RANKING_PAGE);
    LogDebug("players: " . count($players));
    LogDebug("Total Pages: " . $total_pages);

    $rpage = mcc_get_page_parameter(RANKING_PAGE_VARNAME);

    if ( $rpage ) {
        if ( $rpage < 1 ) {
            $rpage = 1;
        }

        if ( $rpage > $total_pages ) {
            $rpage = $total_pages;
        }
    }
    else {
        // This is False or in [0:count($players)-1]
        $player_rank = FALSE;

        for ( $r = 0; $r < count($players); $r++ ) {
            if ( $p_player == $players[$r] ) {
                $player_rank = $r;
                break;
            }
        }

        // not ranking page, always show page one
        $rpage = 1;
    }

    $rank = 1 + ($rpage - 1) * RANKING_PAGE;

    foreach ( array_slice($players, ($rpage - 1) * RANKING_PAGE, RANKING_PAGE) as $player ) {
        if ( $player == $p_player ) {
            $class = "rankings_selected";
        }
        else {
            $class = "rankings";
        }

        if ( $p_linkprofiles ) {
            $link    = "<a href=\"player_profile_view.php?player="
                . $player->getIdentifier() . "\">";
            $linkend = "</a>";
        }
        else {
            $link    = "";
            $linkend = "";
        }

        $result .= "<tr>";
        $result .= "<td class=\"$class\" style=\"text-align: right;\">$rank.</td>";
        $result .= "<td class=\"$class\">$link" . $player->getIdentifier() . "$linkend</td>";
        $result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScoreGames() . "</td>";
        $result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScoreWins() . "</td>";
        $result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScoreDraws() . "</td>";
        $result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScoreLosses() . "</td>";
        $result .= "<td class=\"$class\" style=\"text-align: right;\">" . $player->getScorePoints() . "</td>";
        $result .= "</tr>\n";
        $rank++;
    }

    if ( $total_pages > 1 ) {
        $result .= "<tr><td class=\"rankings_pager\" colspan=\"7\">";

        if ( $rpage > 1 ) {
            $url = mcc_build_url(NULL, RANKING_PAGE_VARNAME, $rpage - 1);
            $result .= "<a href=\"$url\">&lt;</a> &nbsp;";
        }

        $page_first = max(1, $rpage - floor(SHOW_PAGES / 2));
        $page_last  = min($total_pages, $page_first + SHOW_PAGES);

        $result .= "Page &nbsp;";

        for ( $p = $page_first; $p <= $page_last; $p++ ) {
            if ( $rpage == $p ) {
                $result .= "<strong>$p</strong> &nbsp;";
            }
            else {
                $url = mcc_build_url(NULL, RANKING_PAGE_VARNAME, $p);
                $result .= "<a href=\"$url\">$p</a> &nbsp;";
            }
        }

        if ( $rpage < $total_pages ) {
            $url = mcc_build_url(NULL, RANKING_PAGE_VARNAME, $rpage + 1);
            $result .= "<a href=\"$url\">&gt;</a> ";
        }

        $result .= "</td></tr>";
    }

    $rankmin = RANKING_GAMES_MINI;

    $result .= "</table>";

    #--- Build the filter bar

    $filterbar = "<p style=\"text-align: center;\">[ ";

    if ( $filter == RANKING_FILTER_HUMANS ) {
        $filterbar .= "<strong>Show Only Humans</strong>";
    }
    else {
        $url = mcc_build_url(NULL, RANKING_FILTER_VARNAME, RANKING_FILTER_HUMANS);
        $filterbar .= "<a href=\"$url\">Show Only Humans</a>";
    }

    $filterbar .= " | ";

    if ( $filter == RANKING_FILTER_ROBOTS ) {
        $filterbar .= "<strong>Show Only Robots</strong>";
    }
    else {
        $url = mcc_build_url(NULL, RANKING_FILTER_VARNAME, RANKING_FILTER_ROBOTS);
        $filterbar .= "<a href=\"$url\">Show Only  Robots</a>";
    }

    $filterbar .= " | ";

    if ( $filter == RANKING_FILTER_ALL ) {
        $filterbar .= "<strong>Show Both</strong>";
    }
    else {
        $url = mcc_build_url(NULL, RANKING_FILTER_VARNAME, RANKING_FILTER_ALL);
        $filterbar .= "<a href=\"$url\">Show Both</a>";
    }

    $filterbar .= " ]</p>\n";

    $result .= $filterbar;
    #---

    return $result;
}

?>