<?php

/* There are 2 ways to instantiate an EmailToken:
 *
 * Player(identifier, NULL or Token, email_address)
 *   Creates a new Token in the database. If no token
 *   text is given, a new one is generated.
 *
 * Player(NULL, Token, NULL)
 *   Loads a token from the database.
 */
class EmailToken {
	public $token_player;
	public $token_value;
	public $token_email_address;
	public $token_date;

	function EmailToken ( $p_player, $p_value, $p_email ) {
		global $mysql_table_email_token;

		if ( ! $p_value ) {
			$p_value = $this->NewTokenValue();
		}

		if ( ! $p_player || ! $p_email ) {
			$fetch_query = "select et_player, et_token, et_email_address, "
					. "UNIX_TIMESTAMP(et_date) from $mysql_table_email_token "
					. "where et_token='$p_value'";

			$res = sql_query($fetch_query);

			if ( ! empty($res) && ( $row = array_shift($res) ) ) {
				$this->token_player        = $row['et_player'];
				$this->token_value         = $row['et_token'];
				$this->token_email_address = $row['et_email_address'];
				$this->token_date          = $row['UNIX_TIMESTAMP(et_date)'];
			}
			else {
				throw new Exception("Token not found");
			}
		}
		else {
			$insert_query = "insert into $mysql_table_email_token"
					. " set et_player='$p_player', et_token='$p_value',"
					.     " et_email_address='$p_email', et_date=now()";

			sql_exec($insert_query);

			$this->token_player        = $p_player;
			$this->token_value         = $p_value;
			$this->token_email_address = $p_email;
			$this->token_date          = NULL;
		}
	}

	// For public use only
	function NewTokenValue() {
		$token = "";

		while ( strlen($token) < MCC_TOKEN_LENGTH ) {
			$charidx = rand(0, strlen(MCC_TOKEN_CHARS) - 1);
			$token  .= substr(MCC_TOKEN_CHARS, $charidx, 1);
		}

		return $token;
	}

	function getPlayerIdentifier() {
		return $this->token_player;
	}

	function getEmailAddress() {
		return $this->token_email_address;
	}

	function getValue() {
		return $this->token_value;
	}

	function getDate() {
		return $this->token_date;
	}

	function remove() {
		global $mysql_table_email_token;
		sql_exec("delete from $mysql_table_email_token where et_token='"
				. $this->token_value . "'");
	}
};

?>
