<?php

require("../mcc_common.php");
$current_player = mcc_check_login();

$gameid = mcc_get_page_parameter("gameid");
$newtext = mcc_get_page_parameter("text");

$xml = new DOMDocument("1.0", "utf-8");
$xml_notes = $xml->createElement("notes");

if ( $gameid ) {
	try {
		$game = new Game($gameid);
	
		if ( $game->hasPlayer($current_player) ) {
			$note = new Note($current_player, $game);

			if ( $newtext ) {
				$note->setText($newtext);
			}

			$xml_note = $xml->createElement("note");
			$xml_note->setAttribute("owner", $note->note_owner->getIdentifier());
			$xml_note->setAttribute("gameid", $note->note_game->getId());
			$xml_note->appendChild($xml->createTextNode($note->getText()));
			$xml_notes->appendChild($xml_note);
		}
	} catch ( Exception $e ) {
		// Silently ignore a bogus game id
	}
}

$xml->appendChild($xml_notes);

header("content-type: application/xml");
echo $xml->saveXML();
?>
